<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <!-- Mask -->
            <span class="mask bg-gradient-info opacity-8"></span>
            <!-- Header container -->
            <div class="container-fluid d-flex align-items-center">
                <div class="row">
                    <div class="col-lg-12 col-md-10">
                        <h1 class="display-2 text-white">Hello, {{userData.firstname}} {{userData.lastname}}</h1>
                    </div>
                </div>
            </div>
        </base-header>

        <div class="container-fluid mt--7">
            <div class="row">
                <div class="col-xl-12 order-xl-1">
                    <card shadow type="secondary">
                        <div slot="header" class="bg-white border-0">
                            <div class="row align-items-center">
                                <div class="col-8">
                                    <h3 class="mb-0">My username : {{userData.username}}</h3>
                                    <span class="text-danger" v-if="error">{{error}}</span>
                                </div>
                            </div>
                        </div>
                        <template>
                            <form @submit="checkPass">
                                <h6 class="heading-small text-muted mb-4">Change Password</h6>
                                <div class="pl-lg-4">
                                    <div class="row">
                                        <div class="col-lg-6">
                                            <base-input alternative=""
                                                        label="New Password"
                                                        placeholder="New Password"
                                                        type="password"
                                                        input-classes="form-control-alternative"
                                                        v-model="npassword"
                                            />
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-lg-6">
                                            <base-input alternative=""
                                                        label="Re New Password"
                                                        placeholder="Re New Password"
                                                        type="password"
                                                        input-classes="form-control-alternative"
                                                        v-model="rpassword"
                                            />
                                        </div>
                                    </div>
                                </div>
                                <hr class="my-4" />
                                <div class="text-center">
                                    <button class="btn btn-lg btn-primary" type="submit">Change Password</button>
                                </div>
                            </form>
                        </template>
                    </card>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
  export default {
    name: 'user-profile',
    data() {
      return {
        userData : [],
        npassword :'',
        rpassword : '',
        error : ''
      }
    },
    created() {
        this.getProfile()
    },methods: {
        getProfile() {
          //console.log(localStorage.token)
          this.$http.get('/manage/profile',{
          headers: {
            Authorization: 'Bearer ' + localStorage.token
            }
          })
          .then(response => (this.userData = response.data))
        },checkPass(){
            if(this.npassword === ''){
                this.error = 'Please enter new password'
            }else if(this.rpassword === ''){
                this.error = 'Please enter re new password'
            }else if(this.npassword !== this.rpassword){
                this.error = 'Passwords do not match'
            }else{
                this.changePass()
            }
        },
        changePass(){
            this.$swal({
            title: "Confirm change password?",
            icon: "warning",
            buttons: ['cancel','confirm']
          })
          .then((confirm) => {
            if (confirm) {
              this.confirmChangePass()
            }
          })
        },
        confirmChangePass(){
            this.$http.post('/manage/changepass',{
                password : this.npassword
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Password changed!",
                    text : "Do you want to log out?",
                    icon: "success",
                    buttons: ['cancel','go logout']
                })
                .then((confirm) => {
                    if (confirm) {
                        this.$router.push('/logout')
                    }
                })
              }
          })
          .catch(() => this.checkEdituser ())
        },
        checkEdituser(){
            this.error = 'Update failed!!'
        }
    },
  };
</script>
<style></style>
